﻿using DubsBadHygiene;
using HarmonyLib;
using RimWorld;
using Verse;

[StaticConstructorOnStartup]
public static class WashPatientPatch
{
    static WashPatientPatch()
    {
        var harmony = new Harmony("rabiosus.dbhayaracepatch");
        harmony.Patch(
            original: AccessTools.Method(typeof(WorkGiver_washPatient), "ShouldBeWashed"),
            prefix: new HarmonyMethod(typeof(WashPatientPatch), nameof(ShouldBeWashedPrefix))
        );
    }

    public static bool ShouldBeWashedPrefix(Pawn p, ref bool __result)
    {
        // ポーンが有効であることを確認
        if (p == null || p.ageTracker?.CurLifeStage == null)
            return true;

        // 現在のライフステージの`developmentalStage`を取得
        var developmentalStage = p.ageTracker.CurLifeStage.developmentalStage;

        // `DevelopmentalStage.Baby`であれば洗浄対象
        if (developmentalStage == DevelopmentalStage.Baby)
        {
            __result = true; // 洗ゾ
            return false;
        }

        return true;
    }
}
